//                                                                  
// Copyright  2013 Lidor Systems.
// All Rights Reserved.
//
// This SOFTWARE is provided "AS IS", WITHOUT WARRANTY OF ANY KIND.
// either express or implied.                        
//

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using LidorSystems.IntegralUI.Lists;

namespace Columns_Fixed_Width
{
    public partial class Form1 : Form
    {
        #region Initialization
        public Form1()
        {
            InitializeComponent();

            CreateLabelContent();

            InitList();
        }

        private void CreateLabelContent()
        {
            String content = "<div style=\"font:Verdana,9,r\"><p>   In this samplel we are showing how to fix the column width to some value and also how to lock the column to either left or right control side.</p><br></br>";
            content += "<p>   To fix the column width is simple, first select the column from combo box, then change the width and click on Fix Width check box to lock the value from changing. Then click on the Apply button to commit the changes. You wil lnotice that if you want to resize the column using the mouse cursor at the header edge, the column cannot resize its width.</p><br></br>";
            content += "<p>   To fix the column to left or right side, select some column and then choose the side to which you want the column to be fixed.</p><br></br>";
            content += "<p><table width=\"100%\" cellpadding=\"5\"><tr><td width=\"100%\" style=\"align:middleright;textcolor:DarkRed;hovertextcolor:Red\"><a href=\"www.lidorsystems.com/support/articles/winforms/listview/\">More Info ...</a></td></tr></table></p>";
            content += "</div>";

            this.labelInfo.Content = content;
        }

        private void labelInfo_ContentObjectClicked(object sender, LidorSystems.IntegralUI.ObjectClickEventArgs e)
        {
            if (e.Object is LinkLabel)
                System.Diagnostics.Process.Start((e.Object as LinkLabel).Links[0].LinkData.ToString());
        }

        private void InitList()
        {
            this.listView1.SuspendUpdate();

            LidorSystems.IntegralUI.Lists.ListViewColumn column = null;
            for (int j = 1; j <= 5; j++)
            {
                column = new LidorSystems.IntegralUI.Lists.ListViewColumn("Column " + j.ToString(), "Footer " + j.ToString());
                column.Width = 100;

                this.listView1.Columns.Add(column);
                comboColumns.Items.Add(column.HeaderText);
            }

            LidorSystems.IntegralUI.Lists.ListViewItem item = null;
            LidorSystems.IntegralUI.Lists.ListViewSubItem subItem = null;

            for (int i = 1; i <= 100; i++)
            {
                item = new LidorSystems.IntegralUI.Lists.ListViewItem("Item " + i.ToString());

                for (int j = 1; j <= this.listView1.Columns.Count - 1; j++)
                {
                    subItem = new LidorSystems.IntegralUI.Lists.ListViewSubItem("Item " + i.ToString() + j.ToString());
                    item.SubItems.Add(subItem);
                }

                this.listView1.Items.Add(item);
            }

            this.listView1.ResumeUpdate();
        }
        #endregion

        #region Functionality
        private int GetColumnIndex()
        {
            if (comboColumns.SelectedItem != null)
            {
                foreach (LidorSystems.IntegralUI.Lists.ListViewColumn column in this.listView1.Columns)
                {
                    if (column.HeaderText.Equals(comboColumns.SelectedItem.ToString()))
                        return column.Index;
                }
            }

            return -1;
        }

        private void checkFixWidth_CheckedChanged(object sender, EventArgs e)
        {
            numWidth.Enabled = !checkFixWidth.Checked;
        }

        private void btnFixWidth_Click(object sender, EventArgs e)
        {
            int colIndex = GetColumnIndex();
            if (colIndex >= 0 && colIndex < this.listView1.Columns.Count)
            {
                this.listView1.Columns[colIndex].FixedWidth = checkFixWidth.Checked;

                if (!checkFixWidth.Checked)
                    this.listView1.Columns[colIndex].Width = (int)numWidth.Value;
            }
        }

        private void btnFixSide_Click(object sender, EventArgs e)
        {
            int colIndex = GetColumnIndex();
            if (colIndex >= 0 && colIndex < this.listView1.Columns.Count)
            {
                if (rbNone.Checked)
                    this.listView1.Columns[colIndex].Fixed = ColumnFixedType.None;
                else if (rbLeft.Checked)
                    this.listView1.Columns[colIndex].Fixed = ColumnFixedType.Left;
                else if (rbRight.Checked)
                    this.listView1.Columns[colIndex].Fixed = ColumnFixedType.Right;

            }
        }
        #endregion
    }
}