'                                                                  
' Copyright  2013 Lidor Systems.
' All Rights Reserved.
'
' This SOFTWARE is provided "AS IS", WITHOUT WARRANTY OF ANY KIND.
' either express or implied.                        
'

Imports LidorSystems.IntegralUI.Lists

Public Class Form1

#Region "Initialization"
    Public Sub New()
        InitializeComponent()

        CreateLabelContent()

        InitList()
    End Sub

    Private Sub CreateLabelContent()
        Dim content As [String] = "<div style=""font:Verdana,9,r""><p>   In this sample we are showing how to fix the column width to some value and also how to lock the column to either left or right control side.</p><br></br>"
        content += "<p>   To fix the column width is simple, first select the column from combo box, then change the width and click on Fix Width check box to lock the value from changing. Then click on the Apply button to commit the changes. You wil lnotice that if you want to resize the column using the mouse cursor at the header edge, the column cannot resize its width.</p><br></br>"
        content += "<p>   To fix the column to left or right side, select some column and then choose the side to which you want the column to be fixed.</p><br></br>"
        content += "<p><table width=""100%"" cellpadding=""5""><tr><td width=""100%"" style=""align:middleright;textcolor:DarkRed;hovertextcolor:Red""><a href=""www.lidorsystems.com/support/articles/winforms/listview/"">More Info ...</a></td></tr></table></p>"
        content += "</div>"

        Me.labelInfo.Content = content
    End Sub

    Private Sub labelInfo_ContentObjectClicked(ByVal sender As Object, ByVal e As LidorSystems.IntegralUI.ObjectClickEventArgs) Handles labelInfo.ContentObjectClicked
        If TypeOf e.[Object] Is LinkLabel Then
            System.Diagnostics.Process.Start(TryCast(e.[Object], LinkLabel).Links(0).LinkData.ToString())
        End If
    End Sub

    Private Sub InitList()
        Me.listView1.SuspendUpdate()

        Dim column As LidorSystems.IntegralUI.Lists.ListViewColumn = Nothing
        For j As Integer = 1 To 5
            column = New LidorSystems.IntegralUI.Lists.ListViewColumn("Column " & j.ToString(), "Footer " & j.ToString())
            column.Width = 100

            Me.listView1.Columns.Add(column)
            comboColumns.Items.Add(column.HeaderText)
        Next

        Dim item As LidorSystems.IntegralUI.Lists.ListViewItem = Nothing
        Dim subItem As LidorSystems.IntegralUI.Lists.ListViewSubItem = Nothing

        For i As Integer = 1 To 100
            item = New LidorSystems.IntegralUI.Lists.ListViewItem("Item " & i.ToString())

            For j As Integer = 1 To Me.listView1.Columns.Count - 1
                subItem = New LidorSystems.IntegralUI.Lists.ListViewSubItem("Item " & i.ToString() & j.ToString())
                item.SubItems.Add(subItem)
            Next

            Me.listView1.Items.Add(item)
        Next

        Me.listView1.ResumeUpdate()
    End Sub
#End Region

#Region "Functionality"
    Private Function GetColumnIndex() As Integer
        If comboColumns.SelectedItem IsNot Nothing Then
            For Each column As LidorSystems.IntegralUI.Lists.ListViewColumn In Me.listView1.Columns
                If column.HeaderText.Equals(comboColumns.SelectedItem.ToString()) Then
                    Return column.Index
                End If
            Next
        End If

        Return -1
    End Function

    Private Sub checkFixWidth_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles checkFixWidth.CheckedChanged
        numWidth.Enabled = Not checkFixWidth.Checked
    End Sub

    Private Sub btnFixWidth_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnFixWidth.Click
        Dim colIndex As Integer = GetColumnIndex()
        If colIndex >= 0 AndAlso colIndex < Me.listView1.Columns.Count Then
            Me.listView1.Columns(colIndex).FixedWidth = checkFixWidth.Checked

            If Not checkFixWidth.Checked Then
                Me.listView1.Columns(colIndex).Width = CInt(numWidth.Value)
            End If
        End If
    End Sub

    Private Sub btnFixSide_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnFixSide.Click
        Dim colIndex As Integer = GetColumnIndex()
        If colIndex >= 0 AndAlso colIndex < Me.listView1.Columns.Count Then
            If rbNone.Checked Then
                Me.listView1.Columns(colIndex).Fixed = ColumnFixedType.None
            ElseIf rbLeft.Checked Then
                Me.listView1.Columns(colIndex).Fixed = ColumnFixedType.Left
            ElseIf rbRight.Checked Then
                Me.listView1.Columns(colIndex).Fixed = ColumnFixedType.Right

            End If
        End If
    End Sub
#End Region

End Class
